<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 6/11/2018
 * Time: 11:12 AM
 */
$total_found = 0;
$events = FAT_Event_Utils::get_events($shortcode_config, $total_found);
$date_format = isset($shortcode_config['date_format']) && $shortcode_config['date_format'] ? $shortcode_config['date_format'] : ' ';
$time_format = isset($shortcode_config['time_format']) ? $shortcode_config['time_format'] : 'H:i';
$time_format = $time_format!='' ? $time_format : ' ';
$fat_event_setting = get_option('fat_event_setting');
$single_time_format = isset($fat_event_setting['single_time_format']) ? $fat_event_setting['single_time_format'] : 'H:i';
?>
<div class="fat-event-container <?php echo(isset($shortcode_config['enable_animation'][0]) ? $shortcode_config['enable_animation'][0] : ''); ?>"
     data-layout="<?php echo esc_attr($layout); ?>"
     data-sc-id="<?php echo esc_attr($id); ?>"
     data-sc-organizer="<?php echo(isset($atts['filter_organizer']) && $atts['filter_organizer'] ? $atts['filter_organizer'] : ''); ?>"
     data-sc-cat="<?php echo(isset($atts['filter_cat']) && $atts['filter_cat'] ? $atts['filter_cat'] : ''); ?>"
     data-animation="fadeInUp"
     data-animation-duration="200"
     data-spinner="<?php echo esc_attr($shortcode_config['loading_spinner']); ?>"
>
    <div class="fat-event-sc event-timeline"
         data-spinner="<?php echo esc_attr($shortcode_config['loading_spinner']); ?>">
        <section id="cd-timeline" class="cd-container">
            <?php if (count($events) == 0): ?>
                <div class="fat-event-item no-upcoming-event"><?php echo esc_html__('No upcoming event', 'fat-event'); ?></div>
            <?php else:
                $skin_path = untrailingslashit(FAT_EVENT_DIR_PATH) . '/templates/skins/' . (isset($shortcode_config['timeline_skin']) && $shortcode_config['timeline_skin'] ? $shortcode_config['timeline_skin'] : 'timeline-skin-01') . '.php';
                $locale = get_locale();
                if (strpos($locale, '.UTF8') === FALSE && strpos($locale, '.utf8') === FALSE) {
                    $locale .= '.utf8';
                }
                setlocale(LC_TIME, $locale);
                $theme_path = get_stylesheet_directory() . '/templates/fat-event/skins/' . $shortcode_config['timeline_skin'] . '.php';
                if (file_exists($theme_path)) {
                    $skin_path = $theme_path;
                }
                if (file_exists($skin_path)) {
                    $bd_color = '#2171c6';
                    $hourly_schedule = $bg = $time = $single_time = '';
                    foreach ($events as $event) {
                        $bd_color = get_post_meta($event['id'], 'fat-mb-event-color', true);
                        $bd_color = isset($bd_color['color']) && $bd_color['color'] ? $bd_color['color'] : '#2171c6';
                        if ($event['all_day_event'] === '1') {
                            $time = esc_html__('All day - ', 'fat-event') . date_i18n($date_format, $event['start_date']->format('U'));
                            $single_time = $time;
                        } else {
                            $time = $event['start_date']->format($time_format) . ' - ' . $event['end_date']->format($time_format) . ', ' . date_i18n($date_format, $event['start_date']->format('U'));

                            $all_day_event = isset($event['all_day_event'][0]) ? $event['all_day_event'][0] : '';
                            if (isset($event['hide_event_end_time'][0]) && $event['hide_event_end_time'][0] == '1') {
                                $single_time = $event['start_date']->format($single_time_format) . ' - ' . date_i18n($date_format, $event['start_date']->format('U'));
                            } else {
                                if ($all_day_event && date_diff($event['start_date'], $event['end_date'])->d == 0) {
                                    $single_time = esc_html__('All day - ', 'fat-event') . $event['start_date']->format($single_time_format);
                                } else {
                                    if (date_diff($event['start_date'], $event['end_date'])->d == 0) {
                                        $single_time = $event['start_date']->format($single_time_format) . esc_html__(' to ', 'fat-event') . $event['end_date']->format($single_time_format) . ' - ' . date_i18n($date_format, $event['start_date']->format('U'));
                                    } else {
                                        $single_time = $event['start_date']->format($single_time_format . ' ') . date_i18n($date_format, $event['start_date']->format('U')) .  esc_html__(' to ', 'fat-event') . $event['end_date']->format($single_time_format . ' ') .  date_i18n($date_format, $event['end_date']->format('U'));
                                    }
                                }
                            }
                        }
                        include $skin_path;
                    }
                }
            endif; ?>
        </section>
    </div>
</div>