<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 6/12/2018
 * Time: 2:44 PM
 */
?>
<div class="skin-05 <?php echo esc_attr($item_class); ?>" data-event-id="<?php echo esc_attr($event['id']); ?>"  data-time="<?php echo esc_attr($time);?>"
     data-single-time="<?php echo esc_attr($single_time);?>">
    <div class="fat-event-item-inner">
        <a href="<?php echo esc_url($event['link_detail']) ?>" data-open-type="<?php echo esc_attr($event['open_detail_type']);?>"
           target="<?php echo esc_attr($event['link_open_type']); ?>"
           data-s="<?php echo esc_attr($event['start_date']->format('U')); ?>" data-e="<?php echo esc_attr($event['end_date']->format('U')); ?>">
            <div class="fat-event-thumb has-hover-effect">
                <img src="<?php echo ($layout === 'masonry' ? FAT_Event_Utils::get_thumbnail_image_masonry($event['id'], $width, $height):  FAT_Event_Utils::get_thumbnail_image($event['id'], $width, $height) ); ?>"
                     width="<?php echo esc_attr($width); ?>" height="<?php echo esc_attr($height); ?>">

            </div>
        </a>
        <div class="fat-event-info">
            <div class="fat-event-start">
                <span class="event-day">
                    <?php echo esc_attr($event['start_date']->format('d')); ?>
                </span>
                <span class="event-month">
                    <?php echo strftime('%B, %Y',$event['start_date']->getTimestamp());?>
                </span>

                <div class="fat-event-meta-time">
                    <?php if ($event['all_day_event'] === '1'): ?>
                        <span><?php esc_attr_e('All day', 'fat-event'); ?></span>
                    <?php else: ?>
                        <?php if( date_diff($event['start_date'], $event['end_date'])->d == 0) : ?>
                            <span><?php echo $event['start_date']->format($time_format);?>
                                <?php if($shortcode_config['hide_event_end_time'] !== '1'){ esc_html__(' to ', 'fat-event') . $event['end_date']->format($time_format); }?>
                                </span>
                        <?php else: ?>
                            <span>
                                    <?php echo date_i18n($date_format,$event['start_date']->format('U')). ' ' . $event['start_date']->format($time_format); ?>
                                    <?php if($shortcode_config['hide_event_end_time'] !== '1'){ echo esc_html__(' to ', 'fat-event') . date_i18n($date_format,$event['end_date']->format('U')). ' '. $event['end_date']->format($time_format); } ?>
                                </span>
                        <?php endif; ?>
                    <?php endif; ?>
                </div>
            </div>

            <div class="fat-event-meta">
                <div class="fat-event-title">
                    <a href="<?php echo esc_url($event['link_detail']) ?>"
                       data-s="<?php echo esc_attr($event['start_date']->format('U')); ?>" data-e="<?php echo esc_attr($event['end_date']->format('U')); ?>"
                       target="<?php echo esc_attr($event['link_open_type']); ?>"><?php echo get_the_title($event['id']); ?></a>
                </div>
                <?php
                if ($event['location'] && $event['location']!=='' && $event['location']!=='hide' ): ?>
                    <div class="fat-event-location">
                        <?php echo FAT_Event_Utils::get_location_title($event['location'], ', '); ?>
                    </div>
                <?php endif; ?>
            </div>
        </div>
    </div>
</div>